unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, Unit2, ExtCtrls, ColorGrd, Math;
type dword=longint;

type
  Fourcc=array[1..4] of char;
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    ExitProgram1: TMenuItem;
    Edit2: TMenuItem;
    ProgressBar1: TProgressBar;
    Blend2pictures1: TMenuItem;
    Addhue1: TMenuItem;
    Edit3: TEdit;
    LinearFiltering1: TMenuItem;
    Sharpe1: TMenuItem;
    Graypicture1: TMenuItem;
    RotatePicture1: TMenuItem;
    N2files1files1: TMenuItem;
    N1File2Files1: TMenuItem;
    Kp1: TMenuItem;
    Vide1: TMenuItem;
    Edit4: TEdit;
    Button2: TButton;
    Effect1: TMenuItem;
    within2videos1: TMenuItem;
    withpicturesframes1: TMenuItem;
    Blending1: TMenuItem;
    Edgedetect1: TMenuItem;
    LinearFilter1: TMenuItem;
    Hue1: TMenuItem;
    Gray1: TMenuItem;
    Rotate1: TMenuItem;
    Teszt1: TMenuItem;
    ColorDialog1: TColorDialog;
    Kocksods1: TMenuItem;
    Veletlen1: TMenuItem;
    Resizing1: TMenuItem;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    Sztnyils1: TMenuItem;
    Kzprl1: TMenuItem;
    FeliratKisrlet1: TMenuItem;
    Egyfeliatfelillesztse1: TMenuItem;
    FontDialog1: TFontDialog;
    Subfilealillesztse1: TMenuItem;
    Circle21: TMenuItem;
    procedure Button1Click(Sender: TObject);
    function Fourccolvas(var f:file):string;
    //procedure fourccir(var f:file; s:fourcc);
    procedure fourccir(var f:file; szo:fourcc);
    procedure idxir(var h:file; n:integer; widht,height:dword);
    procedure Aviheaderir(var h:file; sec,n:integer; bmp2:tbmphead);
    procedure ExitProgram1Click(Sender: TObject);
    procedure Blend2pictures1Click(Sender: TObject);
    procedure Addhue1Click(Sender: TObject);
    procedure Sharpe1Click(Sender: TObject);
    procedure Graypicture1Click(Sender: TObject);
    procedure RotatePicture1Click(Sender: TObject);
    procedure LinearFiltering1Click(Sender: TObject);
    procedure N2files1files1Click(Sender: TObject);
    procedure N1File2Files1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edgedetect1Click(Sender: TObject);
    procedure Gray1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure LinearFilter1Click(Sender: TObject);
    procedure Blending1Click(Sender: TObject);
    procedure Teszt1Click(Sender: TObject);
    procedure Veletlen1Click(Sender: TObject);
    procedure Resizing1Click(Sender: TObject);
    procedure Kocksods1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Sztnyils1Click(Sender: TObject);
    procedure Kzprl1Click(Sender: TObject);
    procedure Egyfeliatfelillesztse1Click(Sender: TObject);
    procedure Subfilealillesztse1Click(Sender: TObject);
    procedure Circle21Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type TAviheader=record   //Main header
       fc:fourcc;
       cb:DWORD;
       dwMicroSecPerFrame:DWORD;
       dwMaxBytesPerSec:DWORD;
       dwPaddingGranularity:DWORD;
       dwFlags:DWORD;
       dwTotalFrames:DWORD;
       dwInitialFrames:DWORD;
       dwStreams:DWORD;
       dwSuggestedBufferSize:DWORD;
       dwWidth:DWORD;
       dwHeight:DWORD;
       dwReserved:array[1..4] of DWORD;
       end;

type TAvistreamheader=record          //Stream Header
        fcc:fourcc;
        cb:dword;
        fccType:string[4];
        fccHandler:string[4];
        dwFlags:dword;
        dwPriority:dword;
        wLanguage:word;
        dwInitialFrames:dword;
        dwScale:dword;
        dwRate:dword;
        dwStart:dword;
        dwLength:dword;
        dwSuggestedBufferSize:dword;
        dwQuality:dword;
        dwSampleSize:dword;
        rcframe:record
          left:smallint;
          top:smallint;
          right:smallint;
          bottom:smallint;
         end;

        end;

  tpaletta=trgbquad;

  TPbmpMemory=array[0..1200,0..5000] of byte;
  TBmpMemory=^TPbmpMemory;
  tline=array[0..2500] of byte;
  tfileinfo=record
    idxpos,movpos:integer;
    end;

var
  Form1: TForm1;
  olvas:boolean;
  filenev:string;{bemenet}
  kimenet:string;
  nyitva:tbmphead;

implementation

{$R *.DFM}


{Feladata: Egy bmphead-nek bmpinfo mezejet kiirja az f fileba.
Neha ki kell irni a bmdata filehead mezojet is, ezt lehet
szabalyozni az sz logikai valtozoval}

procedure bmp_headkiir(var f:file; bmpdata:TBmpHead; sz:boolean);
begin
if sz then
        begin
        Blockwrite(f,bmpdata.filehead.bfType,sizeof(bmpdata.filehead.bfType));
        Blockwrite(f,bmpdata.filehead.bfsize,sizeof(bmpdata.filehead.bfsize));
        Blockwrite(f,bmpdata.Filehead.bfReserved1,sizeof(bmpdata.filehead.bfReserved1));
        Blockwrite(f,bmpdata.Filehead.bfReserved2,sizeof(bmpdata.filehead.bfReserved2));
        Blockwrite(f,bmpdata.filehead.bfOffBits,sizeof(bmpdata.filehead.bfOffBits));
        end;
Blockwrite(f,bmpdata.Bmpinfo.biSize,sizeof(bmpdata.bmpinfo.bisize));
Blockwrite(f,bmpdata.bmpinfo.biWidth,sizeof(bmpdata.bmpinfo.biwidth));
Blockwrite(f,bmpdata.Bmpinfo.biHeight,sizeof(bmpdata.bmpinfo.biHeight));
Blockwrite(f,bmpdata.bmpinfo.biPlanes,sizeof(bmpdata.bmpinfo.biPlanes));
Blockwrite(f,bmpdata.bmpinfo.biBitCount,sizeof(bmpdata.bmpinfo.biBitCount));
Blockwrite(f,bmpdata.bmpinfo.biCompression,sizeof(bmpdata.bmpinfo.biCompression));
Blockwrite(f,bmpdata.bmpinfo.biSizeimage,sizeof(bmpdata.bmpinfo.biSizeimage));
Blockwrite(f,bmpdata.bmpinfo.biXPelsPerMeter,sizeof(bmpdata.bmpinfo.biXPelsPerMeter));
Blockwrite(f,bmpdata.bmpinfo.biYPelsPerMeter,sizeof(bmpdata.bmpinfo.biYpelspermeter));
Blockwrite(f,bmpdata.bmpinfo.biClrUsed,sizeof(bmpdata.bmpinfo.biClrUsed));
Blockwrite(f,bmpdata.bmpinfo.biClrImportant,sizeof(bmpdata.bmpinfo.biClrimportant));
end;


{Egy bmphead info alapjan kiolvassa f filebol
a bmp kepkockait, majd megjeleniti. Az sz valtozoval
kehet allitani, hogy a szienk milyen sorrendben vannak
tarolva. }
procedure bmp_megjelenit(var f:file; bmp:Tbmphead; sz:byte);
type Tline=array[0..25000] of byte;
var i,j,k:integer;
    scanline:integer;
    line:^tline;
    pal:array[1..2500] of tpaletta;
    c:Tcolor;
begin
if bmp.Bmpinfo.biBitCount=24 then
        begin
        scanline:=bmp.bmpinfo.biwidth*3;
        new(line);
        for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
                begin
                blockread(f,line^,scanline);
                k:=0;
                for j:=0 to bmp.Bmpinfo.biWidth-1 do
                        begin
                        if sz<>1 then form1.canvas.pixels[j,i+80]:=rgb(line^[k],line^[k+2],line^[k+1])
                                 else form1.canvas.pixels[j,i+80]:=rgb(line^[k+2],line^[k+1],line^[k]);
                        k:=k+3;
                        end;
                end;
        dispose(line);
        end else if bmp.Bmpinfo.biBitCount=8 then
                begin
                ScanLine:=bmp.bmpinfo.biWidth*bmp.Bmpinfo.biBitCount div 8;
                new(Line);                    { Uj dinamikus vltoz ltrehozsa   }
                for i:=0 to bmp.Bmpinfo.biClrUsed-1 do
                        blockread(f,pal[i],sizeof(pal[i]));
                for i:=bmp.Bmpinfo.biHeight-1 downto 0 do         { Ennyi sort kell kirajzolni         }
                        begin
                        blockread(F,Line^,Scanline);{ Egy rasztersor beolvassa          }
                        k:=0;                       { Byte-mutat nullzsa              }
                        for j:=0 to bmp.Bmpinfo.biWidth-1 do  { Ennyi oszlop van                   }
                                begin
                                c:=line[k];
                                if sz<>1 then c:=rgb(pal[c].rgbRed,pal[c].rgbgreen,pal[c].rgbBlue)
                                        else c:=rgb(pal[c].rgbRed,pal[c].rgbgreen,pal[c].rgbBlue);
                                form1.canvas.pixels[j,i]:=c;
                                inc(k);                  { Byte-mutat nvelse 1-gyel        }
                                end;
                        end;
                dispose(Line);
                end;

end;

{Ez az egyszeru eljaras kiir egy fourcc-t az f fileba}

procedure Tform1.Fourccir(var f:file; szo:fourcc);
var i:integer;
begin
for i:=1 to 4 do
        begin
        blockwrite(f,szo[i],sizeof(szo[i]));
        end;
end;

{Egy fourcc-t kiolvas f filebol}

function Tform1.Fourccolvas(var f:file):string;
 var szo:fourcc;
     i:integer;
     s:string;
 begin
  for i:=1 to 4 do blockread(f,szo[i],sizeof(szo[i]));
  s:='';
  for i:=1 to 4 do s:=s+szo[i];
  fourccolvas:=s;
 end;

{A bmpheader kiolvasasara alkalmas f filebol.
A szam erteketol fugg hogy ki kell e olvasni a filehead
reszt is.}

procedure bmpolvas(var f:file; var bmpdata:Tbmphead; szam:byte);
begin
//Elkezdjuk a fileheader beolvasasat
if szam=1 then
  begin
   Blockread(f,bmpdata.filehead.bfType,sizeof(bmpdata.filehead.bfType));
   Blockread(f,bmpdata.filehead.bfsize,sizeof(bmpdata.filehead.bfsize));
   Blockread(f,bmpdata.Filehead.bfReserved1,sizeof(bmpdata.filehead.bfReserved1));
   Blockread(f,bmpdata.Filehead.bfReserved2,sizeof(bmpdata.filehead.bfReserved2));
   Blockread(f,bmpdata.filehead.bfOffBits,sizeof(bmpdata.filehead.bfOffBits));
end;
   //Elkezdjuk beolvasni a infoheadert}
//   Blockread(f,bmpdata.Filehead,sizeof(bmpdata.Filehead) 14);
   Blockread(f,bmpdata.Bmpinfo.biSize,sizeof(bmpdata.bmpinfo.bisize));
   Blockread(f,bmpdata.bmpinfo.biWidth,sizeof(bmpdata.bmpinfo.biwidth));
   Blockread(f,bmpdata.Bmpinfo.biHeight,sizeof(bmpdata.bmpinfo.biHeight));
   Blockread(f,bmpdata.bmpinfo.biPlanes,sizeof(bmpdata.bmpinfo.biPlanes));
   Blockread(f,bmpdata.bmpinfo.biBitCount,sizeof(bmpdata.bmpinfo.biBitCount));
   Blockread(f,bmpdata.bmpinfo.biCompression,sizeof(bmpdata.bmpinfo.biCompression));
   Blockread(f,bmpdata.bmpinfo.biSizeimage,sizeof(bmpdata.bmpinfo.biSizeimage));
   Blockread(f,bmpdata.bmpinfo.biXPelsPerMeter,sizeof(bmpdata.bmpinfo.biXPelsPerMeter));
   Blockread(f,bmpdata.bmpinfo.biYPelsPerMeter,sizeof(bmpdata.bmpinfo.biYpelspermeter));
   Blockread(f,bmpdata.bmpinfo.biClrUsed,sizeof(bmpdata.bmpinfo.biClrUsed));
   Blockread(f,bmpdata.bmpinfo.biClrImportant,sizeof(bmpdata.bmpinfo.biClrimportant));
//   Blockread(f,bmpdata.Bmpinfo,sizeof(bmpdata.bmpinfo));
end;


{Az eljaras visszater az avi fejlec fontosabb
infival. A bmp adataival, az avi header -evel es
a stream infokkal}

procedure aviheaderolvas(var f:file;
                         var bmp:TBmpHead;
                         var stream:TAvistreamheader;
                         var head:TAviheader);
var filetype,chunk,listtype:string;
    filesize,listsize,a:dword;
    i:integer;
begin
form1.Caption:=form1.fourccolvas(f);
blockread(f,filesize,sizeof(filesize));

filetype:=form1.fourccolvas(f);

if (form1.Caption<>'RIFF') or (filetype<>'AVI ') then showmessage('Nem Avi file!')
   else begin

        //repeat
        chunk:=form1.fourccolvas(f);
        blockread(f,listsize,sizeof(listsize));
        listtype:=form1.fourccolvas(f);

        if listtype='hdrl' then
                begin
                chunk:=form1.fourccolvas(f);
                if chunk='avih' then  //Avi main header
                        begin
                        //chunk:=fourccolvas(f);
                        blockread(f,head.cb,sizeof(head.cb));
                        blockread(f,head.dwMicroSecPerFrame,sizeof(head.dwMicroSecPerFrame));
                        blockread(f,head.dwMaxBytesPerSec,sizeof(head.dwMaxBytesPerSec));
                        blockread(f,head.dwPaddingGranularity,sizeof(head.dwPaddingGranularity));
                        blockread(f,head.dwFlags,sizeof(head.dwFlags));
                        blockread(f,head.dwTotalFrames,sizeof(head.dwTotalFrames));
                        blockread(f,head.dwInitialFrames,sizeof(head.dwInitialFrames));
                        blockread(f,head.dwStreams,sizeof(head.dwStreams));
                        blockread(f,head.dwSuggestedBufferSize,sizeof(head.dwSuggestedBufferSize));
                        blockread(f,head.dwWidth,sizeof(head.dwWidth));
                        blockread(f,head.dwHeight,sizeof(head.dwHeight));
                        for i:=1 to 4 do blockread(f,head.dwReserved[i],sizeof(head.dwReserved[i]));
                        end;
                end;
              chunk:=form1.fourccolvas(f); //list
              //chunk:=fourccolvas(f); //hossz
              blockread(f,listsize,sizeof(listsize));
              chunk:=form1.fourccolvas(f); //strl
              chunk:=form1.fourccolvas(f); //strh
              if chunk='strh' then  //Stream header
                 begin
                 blockread(f,stream.cb,sizeof(stream.cb));
                 stream.fccType:=form1.fourccolvas(f);
                 stream.fccHandler:=form1.fourccolvas(f);
                 blockread(f,stream.dwFlags,sizeof(stream.dwFlags));
                 blockread(f,stream.dwPriority,sizeof(stream.dwPriority));
                 blockread(f,stream.dwInitialFrames,sizeof(stream.dwInitialFrames));
                 blockread(f,stream.dwScale,sizeof(stream.dwScale));
                 blockread(f,stream.dwRate,sizeof(stream.dwRate));
                 blockread(f,stream.dwStart,sizeof(stream.dwStart));
                 blockread(f,stream.dwLength,sizeof(stream.dwLength));
                 blockread(f,stream.dwSuggestedBufferSize,sizeof(stream.dwSuggestedBufferSize));
                 blockread(f,stream.dwQuality,sizeof(stream.dwQuality));
                 blockread(f,stream.dwSampleSize,sizeof(stream.dwSampleSize));
                 blockread(f,stream.rcFrame,sizeof(stream.rcFrame));
                 //blockread(f,stream.rcFrame,sizeof(stream.rcFrame));
                 //blockread(f,stream.Remarks,sizeof(stream.Remarks));
                 stream.rcframe.top:=stream.rcframe.top;
                 stream.rcframe.left:=stream.rcframe.left;
                 stream.rcframe.right:=stream.rcframe.right;
                 stream.rcframe.bottom:=stream.rcframe.bottom;
                 chunk:=form1.fourccolvas(f);
                 end;

              if chunk='strf' then  //Stream format
                  begin
                  chunk:=form1.fourccolvas(f);//hossz
                  bmpolvas(f,bmp,2);
                  chunk:=form1.fourccolvas(f);
                  if chunk<>'LIST' then
                        begin
                        repeat
                         blockread(f,a,sizeof(a));
                         seek(f,filepos(f)+a);
                         chunk:=form1.fourccolvas(f);
                        until chunk='LIST';
                        end;
                  end;
         end;
end;

{Ez az eljaras enm a legjobb nevet kapta. A lenyeg hogy
megkapjuk az f file mov mezejenek kezdetet, es az idx
mezok kezdetet}

procedure fileinfok(var f:file; var info:tfileinfo);
var bmp:tbmphead;
    head:TAviheader;
    stream:Tavistreamheader;
    listtype,chunk:string[4];
    listsize:dword;
begin
seek(f,0);
aviheaderolvas(f,bmp,stream,head);
chunk:='LIST';

              if chunk='LIST' then
                 begin
                 repeat
                  blockread(f,listsize,sizeof(listsize));
                  listtype:=form1.fourccolvas(f);
                  if listtype<>'movi' then
                        begin
                        seek(f,filepos(f)+listsize-4);
                        chunk:=form1.fourccolvas(f);
                        end;
                 until listtype='movi';
                 end;

        info.movpos:=filepos(f);
        info.idxpos:=filepos(f)+listsize-4;

end;

procedure TForm1.Button1Click(Sender: TObject);

var f:file;

    listtype,chunk:string[4];
    listsize:dword;
    head:TAviheader;
    stream:Tavistreamheader;
    bmp:Tbmphead;
    info:tfileinfo;

begin
opendialog1.execute;
filenev:=opendialog1.filename;
edit1.text:=opendialog1.filename;
Assignfile(f,opendialog1.filename);
reset(f,1);
seek(f,0);
aviheaderolvas(f,bmp,stream,head);
chunk:='LIST';

              if chunk='LIST' then
                 begin
                 repeat
                  blockread(f,listsize,sizeof(listsize));
                  listtype:=form1.fourccolvas(f);
                  if listtype<>'movi' then
                        begin
                        seek(f,filepos(f)+listsize-4);
                        chunk:=form1.fourccolvas(f);
                        end;
                 until listtype='movi';
                 end;

        info.movpos:=filepos(f);
        info.idxpos:=filepos(f)+listsize-4;

        if bmp.bmpinfo.biwidth<445 then form1.width:=445 else form1.width:=bmp.Bmpinfo.biWidth+30;
        if bmp.bmpinfo.biheight<375 then  form1.Height:=445 else form1.Height:=bmp.bmpinfo.biHeight+30;
        if listtype='movi' then
                begin
                chunk:=fourccolvas(f);
                if (chunk='00db') or ((chunk='00dc') and (bmp.Bmpinfo.biCompression=0)) then
                        begin
                        bmp_megjelenit(f,bmp,0);
                        nyitva:=bmp;
                        olvas:=true;
                        end;
                end else showmessage('Unknown Problem!');

closefile(f);
end;


{Ez az eljaras legyartja az avi headerjet midossze harom
parameterbol. Az elso hogy a film milyen hossz, n a framek szama
a bmp2 pedig a bmpinfokat tartalmazza}

procedure Tform1.Aviheaderir(var h:file; sec,n:integer;
                                         bmp2:TbmpHead);
var AviHeader:Taviheader;
    StrHead:TaviStreamHeader;
    chunk:fourcc;
    size:dword;
    i:integer;
    s:string[40];

begin

chunk[1]:='R';chunk[2]:='I';chunk[3]:='F';chunk[4]:='F';
fourccir(h,chunk);
blockwrite(h,size,sizeof(size));
chunk[1]:='A';chunk[2]:='V';chunk[3]:='I';chunk[4]:=' ';
fourccir(h,chunk);
chunk[1]:='L';chunk[2]:='I';chunk[3]:='S';chunk[4]:='T';
fourccir(h,chunk);
size:=4588;
blockwrite(h,size,sizeof(size));

chunk[1]:='h';chunk[2]:='d';chunk[3]:='r';chunk[4]:='l';
fourccir(h,chunk);


Aviheader.fc[1]:='a';
Aviheader.fc[2]:='v';
Aviheader.fc[3]:='i';
Aviheader.fc[4]:='h';
fourccir(h,aviheader.fc);
AviHeader.cb:=56;
blockwrite(h,aviheader.cb,sizeof(aviheader.cb));
AviHeader.dwMicroSecPerFrame:=4000;
blockwrite(h,aviheader.dwMicroSecPerFrame,sizeof(aviheader.dwMicroSecPerFrame));
AviHeader.dwMaxBytesPerSec:=0;
blockwrite(h,aviheader.dwMaxBytesPerSec,sizeof(aviheader.dwMaxBytesPerSec));
AviHeader.dwPaddingGranularity:=0;
blockwrite(h,aviheader.dwPaddingGranularity,sizeof(aviheader.dwPaddingGranularity));
AviHeader.dwFlags:=16;
blockwrite(h,aviheader.dwFlags,sizeof(aviheader.dwFlags));
Aviheader.dwTotalFrames:=n;//sec*25;
blockwrite(h,aviheader.dwTotalFrames,sizeof(aviheader.dwTotalFrames));
AviHeader.dwInitialFrames:=0;
blockwrite(h,aviheader.dwInitialFrames,sizeof(aviheader.dwInitialFrames));
AviHeader.dwStreams:=1;
blockwrite(h,aviheader.dwStreams,sizeof(aviheader.dwStreams));
AviHeader.dwSuggestedBufferSize:=0;
blockwrite(h,aviheader.dwSuggestedBufferSize,sizeof(aviheader.dwSuggestedBufferSize));
AviHeader.dwWidth:=bmp2.Bmpinfo.biWidth;
blockwrite(h,aviheader.dwWidth,sizeof(aviheader.dwWidth));
AviHeader.dwHeight:=bmp2.Bmpinfo.biHeight;
blockwrite(h,aviheader.dwHeight,sizeof(aviheader.dwHeight));
for i:=1 to 4 do AviHeader.dwReserved[i]:=0;
blockwrite(h,AviHeader.dwreserved,sizeof(Aviheader.dwreserved));
//AviHeader.dwReserved:=0;
chunk[1]:='L';chunk[2]:='I';chunk[3]:='S';chunk[4]:='T';
fourccir(h,chunk);
size:=4608-(filepos(h)+4);
blockwrite(h,size,sizeof(size));
chunk[1]:='s';chunk[2]:='t';chunk[3]:='r';chunk[4]:='l';
fourccir(h,chunk);

StrHead.fcc[1]:='s';
StrHead.fcc[2]:='t';
StrHead.fcc[3]:='r';
StrHead.fcc[4]:='h';
fourccir(h,strhead.fcc);
StrHead.cb:=56;
blockwrite(h,strhead.cb,sizeof(strhead.cb));
chunk[1]:='v';chunk[2]:='i';chunk[3]:='d';chunk[4]:='s';
fourccir(h,chunk);
chunk[1]:='D';chunk[2]:='I';chunk[3]:='B';chunk[4]:=' ';
fourccir(h,chunk);



StrHead.dwFlags:=0;
blockwrite(h,strhead.dwFlags,sizeof(strhead.dwFlags));
StrHead.dwPriority:=0;
blockwrite(h,strhead.dwPriority,sizeof(strhead.dwPriority));
StrHead.dwInitialFrames:=0;
blockwrite(h,strhead.dwInitialFrames,sizeof(strhead.dwInitialFrames));
StrHead.dwScale:=1;
blockwrite(h,strhead.dwScale,sizeof(strhead.dwScale));
StrHead.dwRate:=25;
blockwrite(h,strhead.dwRate,sizeof(strhead.dwRate));
StrHead.dwStart:=0;
blockwrite(h,strhead.dwStart,sizeof(strhead.dwStart));
StrHead.dwLength:=n;//25*sec;
blockwrite(h,strhead.dwLength,sizeof(strhead.dwLength));
StrHead.dwSuggestedBufferSize:=0;
blockwrite(h,strhead.dwSuggestedBufferSize,sizeof(strhead.dwSuggestedBufferSize));
StrHead.dwQuality:=-1;
blockwrite(h,strhead.dwQuality,sizeof(strhead.dwQuality));
StrHead.dwSampleSize:=0;
blockwrite(h,strhead.dwSampleSize,sizeof(strhead.dwSampleSize));

StrHead.rcframe.left:=0;
blockwrite(h,strhead.rcframe.left,sizeof(strhead.rcframe.left));
StrHead.rcframe.top:=0;
blockwrite(h,strhead.rcframe.top,sizeof(strhead.rcframe.top));
StrHead.rcframe.right:=bmp2.Bmpinfo.biWidth;
blockwrite(h,strhead.rcframe.right,sizeof(strhead.rcframe.right));
StrHead.rcframe.bottom:=bmp2.Bmpinfo.BiHeight;
blockwrite(h,strhead.rcframe.bottom,sizeof(strhead.rcframe.bottom));

chunk[1]:='s';chunk[2]:='t';chunk[3]:='r';chunk[4]:='f';
fourccir(h,chunk);
size:=bmp2.bmpinfo.biSize;
blockwrite(h,size,sizeof(size));

bmp_headkiir(h,bmp2,false);

chunk[1]:='J';chunk[2]:='U';chunk[3]:='N';chunk[4]:='K';
fourccir(h,chunk);
size:=4608-(filepos(h)+4);
blockwrite(h,size,4);

s:='The video has made by Andrew Szilagyi  ';
blockwrite(h,s,sizeof(s));
s:='                                       ';
s:=datetostr(now);
blockwrite(h,s,sizeof(s));
size:=0;
if filepos(h) mod 4 <>0 then
        begin
        repeat
        blockwrite(h,size,1);
        until filepos(h) mod 4=0
        end;
repeat
blockwrite(h,size,1);
until filepos(h)=4608;

chunk[1]:='L';chunk[2]:='I';chunk[3]:='S';chunk[4]:='T';
fourccir(h,chunk);
size:=(bmp2.Bmpinfo.biHeight*bmp2.Bmpinfo.biWidth*3+8)*n+4;
blockwrite(h,size,sizeof(size));
chunk[1]:='m';chunk[2]:='o';chunk[3]:='v';chunk[4]:='i';
fourccir(h,chunk);
end;


procedure TForm1.ExitProgram1Click(Sender: TObject);
begin
Close;
end;

{Legyartja a framek szamabol, kep szelessegebol, magassagabol
a video indexeit, es kiirja h fileba. }

procedure tform1.idxir(var h:file; n:integer; widht,height:dword);
var chunk:fourcc;
    size,kezdoffset:dword;
    i:integer;
begin

  chunk[1]:='i';chunk[2]:='d';chunk[3]:='x';chunk[4]:='1';
  fourccir(h,chunk);
  size:=16*n;
  blockwrite(h,size,sizeof(size));
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  kezdoffset:=4;
  for i:=1 to n do
        begin
        fourccir(h,chunk);
        size:=16;
        blockwrite(h,size,sizeof(size));
        size:=Widht*Height*3;
        size:=kezdoffset+(i-1)*(size+8);
        blockwrite(h,size,sizeof(size));
        size:=Widht*Height*3;
        blockwrite(h,size,sizeof(size));
        end;
end;

{Az f file aktualis poziciojatol kiolvasom egy komplett
bmp tartalmat a memoriaba. }

procedure bitmaptomemory(var f:file; bmp:TBmpHead; var bmpmemory:TBmpMemory);
var i,j,k:integer;
scanline:integer;
line:^tline;
begin
scanline:=bmp.bmpinfo.biWidth*3;
new(line);
if scanline mod 4<>0 then showmessage('Hibas scanline!')
   else begin
        for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
                begin
                blockread(f,line^,scanline);
                k:=0;
                for j:=0 to bmp.Bmpinfo.biWidth-1 do
                        begin
                        bmpmemory^[i,k]:=line^[k];
                        bmpmemory^[i,k+1]:=line^[k+1];
                        bmpmemory^[i,k+2]:=line^[k+2];
                        k:=k+3;
                        end;
                end;
        end;
dispose(line);
end;


{canvas egy reszet (ahol a film van), belerakja a memoriaba,
igy rarajzolas utan is ki lehet tenni fileba}

procedure canvastomemory(var bmpmemory:TBmpMemory; rect:trect);
var i,j,k:integer;
    scanline:integer;
    color:tcolor;
    cr,cg,cb:byte;
begin
scanline:=(rect.Right-rect.left)*3;
if scanline mod 4<>0 then showmessage('Hibas scanline!')
   else begin
        for i:=rect.bottom-rect.top-1 downto 0 do
                begin
                //blockread(f,line^,scanline);
                k:=0;
                for j:=0 to rect.Right-rect.left-1 do
                        begin
                        color:=form1.Canvas.Pixels[rect.left+j,rect.top+i];
                        cr:=getrvalue(color);
                        cg:=getgvalue(color);
                        cb:=getbvalue(color);
                        bmpmemory^[i,k]:=cb;
                        bmpmemory^[i,k+1]:=cg;
                        bmpmemory^[i,k+2]:=cr;
                        k:=k+3;
                        end;
                end;
        end;
end;


{Ket bmp fejlecet hasonlit ossze.}

procedure osszehasonlit(bmp1,bmp2:tbmphead; var k:boolean);
begin
k:=true;
if bmp1.Bmpinfo.biWidth<>bmp2.Bmpinfo.biWidth then k:=false
        else if bmp1.Bmpinfo.biHeight<>bmp2.Bmpinfo.biHeight then k:=false
                else if bmp1.Bmpinfo.biBitCount<>bmp2.Bmpinfo.biBitCount then k:=false;
{                        else if bmp1.Bmpinfo.biXPelsPerMeter<>bmp2.Bmpinfo.biXPelsPerMeter then k:=false
                                else if bmp1.Bmpinfo.biYPelsPerMeter<>bmp2.Bmpinfo.biYPelsPerMeter then k:=false;}
end;

{A memoriaban eltarol kepet irja vissza fileba.}

procedure bmpkiir(var f:file; bmp:Tbmpmemory; bmph:Tbmphead);
var i,j:integer;
    scanline:integer;
    line:^Tline;
begin
new(line);
scanline:=bmph.Bmpinfo.biWidth*3;
if scanline mod 4 <>0 then showmessage('Hiba with the scanline')
        else begin
             for i:=bmph.Bmpinfo.biHeight-1 downto 0 do
                begin
                for j:=0 to bmph.Bmpinfo.biWidth*3-3 do
                        begin
                        line^[j]:=bmp^[i,j];
                        end;
                blockwrite(f,line^,scanline);
                end;
             end;
dispose(line);
end;

function blending(bmp1,bmp2:Tbmpmemory; bmp:Tbmphead; n,m:integer):TBmpmemory;
var i,j:integer;
    blend:tbmpmemory;
begin
new(blend);
for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
        begin
        for j:=0 to bmp.bmpinfo.biWidth*3-3 do blend^[i,j]:=round((bmp1^[i,j]*m+bmp2^[i,j]*(n-m))/n);
        end;
blending:=blend;
end;


procedure TForm1.Blend2pictures1Click(Sender: TObject);
var Bmp1,Bmp2:TBmpHead;
    bmp1m,bmp2m,bmp3m:Tbmpmemory;
    f,g,h:file;
    m,sec,n:integer;
    chunk:fourcc;
    size:dword;
    kulonbseg:boolean;
begin
new(bmp1m);
new(bmp2m);
new(bmp3m);
opendialog1.execute;
assignfile(f,opendialog1.filename);
Reset(f,1);
opendialog1.execute;
assignfile(g,opendialog1.filename);
reset(g,1);

assignfile(h,kimenet);
rewrite(h,1);

sec:=strtoint(edit3.text);
n:=sec*25;
bmpolvas(f,bmp1,1);
bmpolvas(g,bmp2,1);
bitmaptomemory(f,bmp1,bmp1m);
bitmaptomemory(g,bmp2,bmp2m);


rewrite(h,1);

osszehasonlit(bmp1,bmp2,kulonbseg);

if kulonbseg then
  begin

  Aviheaderir(h,sec,n,bmp2);

  progressbar1.Min:=0;
  progressbar1.Max:=n;
  progressbar1.Position:=1;

  for m:=0 to n-1 do
    begin

    chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
    fourccir(h,chunk);
    size:=bmp1.Bmpinfo.biWidth*bmp1.Bmpinfo.biHeight*3;
    blockwrite(h,size,sizeof(size));

    bmp3m:=blending(bmp1m,bmp2m,bmp1,n,m);
    bmpkiir(h,bmp3m,bmp1);
    progressbar1.StepBy(1);
  end;

  idxir(h,n,bmp1.bmpinfo.biwidth,bmp1.bmpinfo.biheight);
  closefile(f);
  closefile(g);
  closefile(h);
  showmessage('Kesz');
  end else
        begin
        closefile(f);
        closefile(g);
        closefile(h);
        showmessage('Hiba: A ket kepfile nem osszerakhato!');
        end;

dispose(bmp1m);
dispose(bmp2m);
dispose(bmp3m);
end;

function huefv(bmpm:tbmpmemory; bmp:tbmphead; n,m,g:integer):Tbmpmemory;
var i,j:integer;
    h:tbmpmemory;
begin
new(h);
for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
        begin
        for j:=0 to (bmp.Bmpinfo.biWidth-1)*3 do
                begin
                if bmpm^[i,j]+round(g/(n+1)*m)<=255
                then h^[i,j]:=bmpm^[i,j]+round(g/(n+1)*m) else h^[i,j]:=255;

                end;
        end;
huefv:=h;
end;

procedure TForm1.Addhue1Click(Sender: TObject);
var Bmp1:TBmpHead;
    f,h:file;
    m,sec,n,hue:integer;
    bmpm,ki:Tbmpmemory;
    chunk:fourcc;
    size:dword;

begin
opendialog1.execute;
assignfile(f,opendialog1.filename);
Reset(f,1);

assignfile(h,kimenet);
rewrite(h,1);
new(bmpm);
new(ki);

sec:=strtoint(edit3.text);
n:=sec*25;
hue:=strtoint(inputbox('Hue megadasa','Krem rja be mennyi fnyt adjak hozz: ','0'));

bmpolvas(f,bmp1,1);
bitmaptomemory(f,bmp1,bmpm);
rewrite(h,1);


  Aviheaderir(h,sec,n,bmp1);

  progressbar1.Min:=0;
  progressbar1.Max:=n;
  progressbar1.Position:=1;
  for m:=1 to n do
  begin
  reset(f,1);
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  fourccir(h,chunk);
  size:=bmp1.Bmpinfo.biWidth*bmp1.Bmpinfo.biHeight*3;
  blockwrite(h,size,sizeof(size));
  ki:=huefv(bmpm,bmp1,n,m,hue);
  bmpkiir(h,ki,bmp1);
  progressbar1.StepBy(1);
  end;

  idxir(h,n,bmp1.bmpinfo.biwidth,bmp1.bmpinfo.biheight);

  showmessage('Kesz');

closefile(f);
closefile(h);
dispose(bmpm);
dispose(ki);
end;

function edge(bmpm:Tbmpmemory; bmp:tbmphead; elter:integer):Tbmpmemory;
var i,j,k:integer;
    r,g,b,r1,g1,b1,r2,g2,b2:integer;
    ed:tbmpmemory;
begin
new(ed);
for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
        begin
        k:=0;
        for j:=0 to bmp.Bmpinfo.biWidth-1 do
                begin
                r:=bmpm^[i,k+2];
                g:=bmpm^[i,k+1];
                b:=bmpm^[i,k];
                r1:=bmpm^[i+1,k+2];
                g1:=bmpm^[i+1,k+1];
                b1:=bmpm^[i+1,k];
                r2:=bmpm^[i,k+5];
                g2:=bmpm^[i,k+4];
                b2:=bmpm^[i,k+3];
                k:=k+3;
                //form1.Canvas.Pixels[j,i+25]:=rgb(b,g,r);

                if (sqrt((r-r1)*(r-r1)+ (g-g1)*(g-g1) + (b-b1)*(b-b1))>=elter) or
                    (sqrt((r-r2)*(r-r2)+ (g-g2)*(g-g2) + (b-b2)*(b-b2))>=elter) then
                        begin
                        ed^[i,k]:=255;
                        ed^[i,k+1]:=255;
                        ed^[i,k+2]:=255;
                        end else
                            begin
                            ed^[i,k]:=0;
                            ed^[i,k+1]:=0;
                            ed^[i,k+2]:=0;
                            end;
                end;
        end;
edge:=ed;

end;

procedure TForm1.Sharpe1Click(Sender: TObject);
var bmp:TbmpHead;
    chunk:fourcc;
    f,h:file;
    bmpm,ki:TBmpmemory;
    size,sec,n,m:integer;
    elteres,selteres,elteres2:integer;

begin
new(bmpm);
new(ki);
opendialog1.execute;
assignfile(f,opendialog1.filename);
Reset(f,1);
assignfile(h,kimenet);
rewrite(h,1);
bmpolvas(f,bmp,1);
bitmaptomemory(f,bmp,bmpm);
sec:=strtoint(edit3.text);
n:=sec*25;

Aviheaderir(h,sec,n,bmp);

selteres:=strtoint(inputbox('Adja meg az elteres elejet: ','Adja meg az elteres elejet: ','15'));
elteres:=strtoint(inputbox('Adja meg az elteres veget: ','Adja meg az veget: ','40'));
elteres:=abs(selteres-elteres);

progressbar1.Min:=0;
progressbar1.Max:=n;
progressbar1.Position:=1;
for m:=1 to n do
  begin
  elteres2:=round(elteres/(n+1)*m)+selteres;
  reset(f,1);
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  fourccir(h,chunk);
  size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
  blockwrite(h,size,sizeof(size));
  progressbar1.StepBy(1);
  ki:=edge(bmpm,bmp,elteres2);
  bmpkiir(h,ki,bmp);
  end;

idxir(h,n,bmp.bmpinfo.biwidth,bmp.bmpinfo.biheight);
closefile(f);
showmessage('Kesz');
dispose(bmpm);
dispose(ki);
end;

function gray(bmpm:tbmpmemory; bmp:tbmphead; m:integer ):tbmpmemory;
var i,j,k:integer;
    g:tbmpmemory;
    gr:integer;
begin
new(g);
   for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
        begin
        k:=0;
        for j:=0 to bmp.Bmpinfo.biWidth-1 do
                begin
                gr:=round((bmpm[i,k]+bmpm[i,k+1]+bmpm[i,k+2])/3);
                if gr+m<255 then g^[i,k]:=gr+m else g^[i,k]:=255;
                if gr+m<255 then g^[i,k+1]:=gr+m else g^[i,k+1]:=255;
                if gr+m<255 then g^[i,k+2]:=gr+m else g^[i,k+2]:=255;
                k:=k+3;
                end;
        end;
gray:=g;
end;

procedure TForm1.Graypicture1Click(Sender: TObject);
var bmp:TbmpHead;
    chunk:fourcc;
    f,h:file;
    bmpm,ki:TBmpmemory;
    size,sec,n,m:integer;

begin
new(bmpm);
new(ki);
opendialog1.execute;
assignfile(f,opendialog1.filename);
Reset(f,1);
assignfile(h,kimenet);
rewrite(h,1);
bmpolvas(f,bmp,1);
bitmaptomemory(f,bmp,bmpm);
sec:=strtoint(edit3.text);
n:=sec*25;

Aviheaderir(h,sec,n,bmp);

progressbar1.Min:=0;
progressbar1.Max:=n;
progressbar1.Position:=1;
for m:=1 to n do
  begin
  reset(f,1);
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  fourccir(h,chunk);
  size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
  blockwrite(h,size,sizeof(size));
  ki:=gray(bmpm,bmp,m);
  bmpkiir(h,ki,bmp);
  progressbar1.StepBy(1);
  end;

idxir(h,n,bmp.bmpinfo.biwidth,bmp.bmpinfo.biheight);
closefile(f);
showmessage('Kesz');
dispose(bmpm);
dispose(ki);

end;

function rotate(bmpm:tbmpmemory; bmp:tbmphead; x0,y0:integer; alfa:real):tbmpmemory;
var i,j,k:integer;
    xe,ye:integer;
    calfa,salfa:real;
    sv,sv2:real;
    rot:tbmpmemory;
begin
new(rot);
calfa:=cos(-1*alfa);
salfa:=sin(-1*alfa);
for j:=bmp.Bmpinfo.biHeight-1 downto 0 do
        begin
        k:=0;
        for i:=0 to bmp.Bmpinfo.biWidth-1 do
                begin
                ye:=0;
                xe:=0;

                sv:=(i-x0)*calfa;
                sv2:=(j-y0)*salfa;
                xe:=round(sv-sv2)+x0;
                if (xe<0) or (xe>bmp.Bmpinfo.biWidth) then
                  begin
                  xe:=0;
                  ye:=0;
                  end else
                        begin
                        sv:=(i-x0)*salfa;
                        sv2:=(j-y0)*calfa;
                        ye:=round(sv+sv2);
                        ye:=ye+y0;
                        if (ye<0)or (ye>bmp.bmpinfo.biheight) then
                                begin
                                ye:=0;
                                xe:=0;
                                end;
                        end;
                rot^[j,k]:=bmpm^[ye,3*xe];
                rot^[j,k+1]:=bmpm^[ye,3*xe+1];
                rot^[j,k+2]:=bmpm^[ye,3*xe+2];
                //form1.Canvas.Pixels[i+50,j]:=rgb(line3^[k+2],line3^[k+1],line3^[k]);
                k:=k+3;
                end;
        end;
rotate:=rot;
end;


procedure TForm1.RotatePicture1Click(Sender: TObject);
var bmp:TbmpHead;
    chunk:fourcc;
    f,h:file;
    bmpm,ki:TBmpmemory;
    size,sec,n,m,korok:integer;
    x0,y0:integer;
    alfa:real;

begin
korok:=strtoint(inputbox('Korok szama: ','Korok szama','5'));
new(bmpm);
opendialog1.execute;
assignfile(f,opendialog1.filename);
Reset(f,1);
assignfile(h,kimenet);
rewrite(h,1);
bmpolvas(f,bmp,1);
bitmaptomemory(f,bmp,bmpm);
sec:=strtoint(edit3.text);
n:=sec*25;

Aviheaderir(h,sec,n,bmp);

progressbar1.Min:=0;
progressbar1.Max:=n;
progressbar1.Position:=1;
//alfa:=45;
for m:=1 to n do
  begin
  reset(f,1);
  alfa:=korok*round(360/(n+1)*m);
  alfa:=-1*alfa;
  alfa:=alfa/180*pi;
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  fourccir(h,chunk);
  size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
  blockwrite(h,size,sizeof(size));
  //alfa:=alfa+round(360/n);
  x0:=round(bmp.Bmpinfo.biWidth/2);
  y0:=round(bmp.bmpinfo.biheight/2);
  ki:=rotate(bmpm,bmp,x0,y0,alfa);
  bmpkiir(h,ki,bmp);
  progressbar1.StepBy(1);
  end;

idxir(h,n,bmp.bmpinfo.biwidth,bmp.bmpinfo.biheight);
closefile(f);
showmessage('Kesz');
dispose(ki);
dispose(bmpm);
end;

function linear(bmpm:tbmpmemory; bmp:tbmphead; r:integer):tbmpmemory;
var i,j,k,l,c,db,szumr,szumg,szumb:integer;
    lin:tbmpmemory;
begin
new(lin);
for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
        begin
        c:=0;
        for j:=0 to bmp.Bmpinfo.biWidth-1 do
                begin
                db:=0;
                szumr:=0;
                szumg:=0;
                szumb:=0;
                for k:=i-r to i+r do
                    begin
                    for l:=j-r to j+r do
                        begin
                        if (k>=0) and (k<=bmp.Bmpinfo.biHeight-1)
                             and (l>=0) and (l<=bmp.bmpinfo.biWidth-1) then
                             begin
                              inc(db);
                              szumr:=szumr+bmpm^[k,l*3];
                              szumg:=szumg+bmpm^[k,l*3+1];
                              szumb:=szumb+bmpm^[k,l*3+2];
                             end;
                        end;
                    end;
                lin^[i,c]:=round(szumr/db);
                lin^[i,c+1]:=round(szumg/db);
                lin^[i,c+2]:=round(szumb/db);
                c:=c+3;
                end;
        end;
linear:=lin;
end;

procedure TForm1.LinearFiltering1Click(Sender: TObject);
var f,h:file;
    bmp:tbmphead;
    bmpm,ki:Tbmpmemory;
    sec,n,m,r,r1,db:integer;
    chunk:fourcc;
    size:integer;
begin
opendialog1.execute;
new(bmpm);
new(ki);
assignfile(f,opendialog1.filename);
Reset(f,1);
assignfile(h,kimenet);
rewrite(h,1);
bmpolvas(f,bmp,1);
bitmaptomemory(f,bmp,bmpm);
sec:=strtoint(edit3.text);
n:=sec*25;
r1:=strtoint(inputbox('Sugar megadasa: ','Kerem adjon meg egy sugarat','5'));

Aviheaderir(h,sec,n,bmp);

progressbar1.Min:=0;
progressbar1.Max:=n;
progressbar1.Position:=1;
for m:=1 to n do
  begin
  r:=round(r1/(n+1)*m);
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  fourccir(h,chunk);
  size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
  blockwrite(h,size,sizeof(size));
  ki:=linear(bmpm,bmp,r);
  bmpkiir(h,ki,bmp);
  progressbar1.stepby(1);
  end;
idxir(h,n,bmp.bmpinfo.biwidth,bmp.bmpinfo.biheight);
dispose(ki);
dispose(bmpm);
closefile(f);
showmessage('Kesz');
end;

procedure TForm1.N2files1files1Click(Sender: TObject);
var f,g,h:file;
    listtype,chunk:string[4];
    chun:fourcc;
    listsize:dword;
    head1,head2:TAviheader;
    stream1,stream2:Tavistreamheader;
    bmp1,bmp2:Tbmphead;
    k:boolean;
    sec,n,sv,size,i,j:integer;
    line:^tline;

begin
opendialog1.execute;
edit1.text:=opendialog1.filename;
Assignfile(f,opendialog1.filename);
reset(f,1);
seek(f,0);
opendialog1.Execute;
Assignfile(g,opendialog1.FileName);
reset(g,1);
seek(g,0);
Assignfile(h,kimenet);
rewrite(h,1);
aviheaderolvas(f,bmp1,stream1,head1);
aviheaderolvas(g,bmp2,stream2,head2);
osszehasonlit(bmp1,bmp2,k);
sec:=head1.dwTotalFrames;
n:=round(stream1.dwRate/stream1.dwScale);
sec:=round(sec/n);
sv:=head2.dwTotalFrames;
n:=round(stream2.dwRate/stream2.dwScale);
sv:=round(sv/n);
sec:=sec+sv;
n:=sec*25;
new(line);
progressbar1.Min:=0;
progressbar1.Max:=n;
progressbar1.Position:=1;

if k then
        begin
        aviheaderir(h,sec,n,bmp1);

               chunk:='LIST';

              if chunk='LIST' then
                 begin
                 repeat
                  blockread(f,listsize,sizeof(listsize));
                  listtype:=fourccolvas(f);
                  if listtype<>'movi' then
                        begin
                        seek(f,filepos(f)+listsize-4);
                        chunk:=fourccolvas(f);
                        end;
                 until listtype='movi';
                 end;

              if listtype='movi' then
                begin
                chunk:=fourccolvas(f);
                    repeat
                     if (chunk='00db') or ((chunk='00dc') and (bmp1.Bmpinfo.biCompression=0)) then
                        begin
                        chun[1]:='0';chun[2]:='0';chun[3]:='d';chun[4]:='c';
                        fourccir(h,chun);
                        size:=bmp1.Bmpinfo.biWidth*bmp1.Bmpinfo.biHeight*3;
                        blockwrite(h,size,sizeof(size));
                        blockread(f,size,sizeof(size));
                        for i:=bmp1.Bmpinfo.biHeight-1 downto 0 do
                                begin
                                blockread(f,line^,bmp1.bmpinfo.biwidth*3);
                                blockwrite(h,line^,bmp1.bmpinfo.biwidth*3);
                                end;
                        progressbar1.stepby(1);
                        chunk:=fourccolvas(f);
                        end;
                    until (chunk='idx1') or (eof(f));
               end;
              chunk:='LIST';

              if chunk='LIST' then
                 begin
                 repeat
                  blockread(g,listsize,sizeof(listsize));
                  listtype:=fourccolvas(g);
                  if listtype<>'movi' then
                        begin
                        seek(g,filepos(g)+listsize-4);
                        chunk:=fourccolvas(g);
                        end;
                 until listtype='movi';
                 end;

              if listtype='movi' then
                begin
                chunk:=fourccolvas(g);
                    repeat
                     if (chunk='00db') or ((chunk='00dc') and (bmp1.Bmpinfo.biCompression=0)) then
                        begin
                        chun[1]:='0';chun[2]:='0';chun[3]:='d';chun[4]:='c';
                        fourccir(h,chun);
                        size:=bmp1.Bmpinfo.biWidth*bmp1.Bmpinfo.biHeight*3;
                        blockwrite(h,size,sizeof(size));
                        blockread(g,size,sizeof(size));
                        for i:=bmp1.Bmpinfo.biHeight-1 downto 0 do
                                begin
                                blockread(g,line^,bmp1.bmpinfo.biwidth*3);
                                blockwrite(h,line^,bmp1.bmpinfo.biwidth*3);
                                end;
                        progressbar1.stepby(1);
                        chunk:=fourccolvas(g);
                        end;
                    until (chunk='idx1') or (eof(g));
                idxir(h,n,bmp1.bmpinfo.biwidth,bmp1.bmpinfo.biheight);
                end;
        showmessage('Kesz!');
        closefile(f);
        end else
            begin
            showmessage('A ket file nem rakhato ossze.');
            closefile(f);
            end;


closefile(g);
closefile(h);
dispose(line);

end;

procedure TForm1.N1File2Files1Click(Sender: TObject);
var f,g,h:file;
    bmp:TBmphead;
    sec,n,m:integer;
    stream:Tavistreamheader;
    Head:Taviheader;
    vagassec:integer;
    listsize,i,j,gsec,hsec,size:integer;
    chunk,listtype:string[4];
    chun:fourcc;
    line:^Tline ;

begin
opendialog1.execute;
new(line);
Assignfile(f,opendialog1.filename);
reset(f,1);
aviheaderolvas(f,bmp,stream,head);
vagassec:=strtoint(inputbox('Hol vagjam el a videot? ','Vagas helye: ','1'));
showmessage('A kimenet output1 es output2.avi lesz!');
Assignfile(g,'output1.avi');
Assignfile(h,'output2.avi');
rewrite(g,1);
rewrite(h,1);

sec:=head.dwTotalFrames;
n:=round(stream.dwRate/stream.dwScale);
sec:=round(sec/n);
if vagassec<sec then
        begin
        gsec:=vagassec;
        hsec:=sec-gsec;

        n:=gsec*25;
        //G megirasa
        aviheaderir(g,gsec,n,bmp);

        chunk:='LIST';

        if chunk='LIST' then
           begin
           repeat
           blockread(f,listsize,sizeof(listsize));
           listtype:=fourccolvas(f);
           if listtype<>'movi' then
                      begin
                      seek(f,filepos(f)+listsize-4);
                      chunk:=fourccolvas(f);
                      end;
            until listtype='movi';
            end;


            progressbar1.min:=0;
            progressbar1.Max:=sec*25;
            progressbar1.Position:=0;
            if listtype='movi' then
                begin

                chunk:=form1.fourccolvas(f);
                m:=0;
                repeat
                if (chunk='00db') or ((chunk='00dc') and (bmp.Bmpinfo.biCompression=0)) then
                        begin
                        blockread(f,size,sizeof(size));
                        chun[1]:='0';chun[2]:='0';chun[3]:='d';chun[4]:='c';
                        fourccir(g,chun);
                        blockwrite(g,size,sizeof(size));
                        for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
                                begin
                                blockread(f,line^,bmp.Bmpinfo.biWidth*3);
                                blockwrite(g,line^,bmp.Bmpinfo.biWidth*3);
                                end;
                        end;
                chunk:=form1.fourccolvas(f);
                progressbar1.StepBy(1);
                m:=m+1;
                until (m>n) or (chunk='idx1') or (eof(f));
                idxir(g,n,bmp.bmpinfo.biwidth,bmp.bmpinfo.biheight);


                n:=hsec*25-1;
                aviheaderir(h,hsec,n,bmp);
                m:=0;
                repeat
                if (chunk='00db') or ((chunk='00dc') and (bmp.Bmpinfo.biCompression=0)) then
                        begin
                        blockread(f,size,sizeof(size));
                        chun[1]:='0';chun[2]:='0';chun[3]:='d';chun[4]:='c';
                        fourccir(h,chun);
                        blockwrite(h,size,sizeof(size));
                        for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
                                begin
                                blockread(f,line^,bmp.Bmpinfo.biWidth*3);
                                blockwrite(h,line^,bmp.Bmpinfo.biWidth*3);
                                end;
                        end;
                chunk:=form1.fourccolvas(f);
                progressbar1.StepBy(1);
                m:=m+1;
                until (m>n) or (chunk='idx1') or (eof(f));
                //showmessage(inttostr(m));
                idxir(h,n,bmp.bmpinfo.biwidth,bmp.bmpinfo.biheight);
                showmessage('Kesz!');
                end;


            end else showmessage('Vagas ido rossz!');

closefile(f);
closefile(g);
closefile(h);
dispose(line);

end;

procedure TForm1.FormActivate(Sender: TObject);
begin
olvas:=false;
kimenet:=edit5.Text;
end;

function kepkocka(var f:file; info:tfileinfo; melyik:integer):integer;
var pos:dword;
begin
reset(f,1);
seek(f,info.idxpos+8);
//chunk:=fourccolvas(f);
pos:=16*melyik;
seek(f,filepos(f)+pos+8);
blockread(f,pos,sizeof(pos));
kepkocka:=pos+info.movpos+4;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
    f:file;
    pos:dword;
    info:tfileinfo;
begin
if olvas=false then showmessage('Please open a file!') else
        begin
        Assignfile(f,filenev);
        reset(f,1);
        fileinfok(f,info);
        pos:=kepkocka(f,info,strtoint(edit4.text));
        seek(f,pos);
        bmp_megjelenit(f,nyitva,1);
        closefile(f);
        end;
end;

procedure TForm1.Edgedetect1Click(Sender: TObject);
var f:file;
    pos:dword;
    bmp:tbmphead;
    bmpm:tbmpmemory;
    i:integer;
    start,ending:integer;
    info:tfileinfo;
begin
new(bmpm);
start:=strtoint(inputbox('Start','Start','1'));
ending:=strtoint(inputbox('End','End','100'));
if olvas=false then showmessage('Please open a file!') else
        begin
        Assignfile(f,filenev);
        reset(f,1);
        fileinfok(f,info);
        reset(f,1);
        progressbar1.Min:=start;
        progressbar1.max:=ending;
        progressbar1.Position:=start;
        for i:=start to ending do
                begin
                pos:=kepkocka(f,info,i);
                seek(f,pos);
                bitmaptomemory(f,nyitva,bmpm);
                bmpm:=edge(bmpm,nyitva,30);
                seek(f,pos);
                bmpkiir(f,bmpm,nyitva);
                progressbar1.StepBy(1);
                end;
        showmessage('Kesz!');
        closefile(f);
        end;
dispose(bmpm);
end;

procedure TForm1.Gray1Click(Sender: TObject);
var f:file;
    pos:dword;
    bmp:tbmphead;
    bmpm:tbmpmemory;
    i:integer;
    start,ending:integer;
    info:tfileinfo;
begin
new(bmpm);
start:=strtoint(inputbox('Start','Start','1'));
ending:=strtoint(inputbox('End','End','100'));
if olvas=false then showmessage('Please open a file!') else
        begin
        Assignfile(f,filenev);
        reset(f,1);
        fileinfok(f,info);
        reset(f,1);
        progressbar1.Min:=start;
        progressbar1.max:=ending;
        progressbar1.Position:=start;
        for i:=start to ending do
                begin
                pos:=kepkocka(f,info,i);
                seek(f,pos);
                bitmaptomemory(f,nyitva,bmpm);
                bmpm:=gray(bmpm,nyitva,0);
                seek(f,pos);
                bmpkiir(f,bmpm,nyitva);
                progressbar1.StepBy(1);
                end;
        showmessage('Kesz!');
        closefile(f);
        end;
dispose(bmpm);
end;

procedure TForm1.Rotate1Click(Sender: TObject);
var f:file;
    pos:dword;
    bmp:tbmphead;
    bmpm:tbmpmemory;
    i:integer;
    start,ending:integer;
    fok:real;
    info:tfileinfo;
begin
new(bmpm);
start:=strtoint(inputbox('Start','Start','1'));
ending:=strtoint(inputbox('End','End','100'));
fok:=strtoint(inputbox('Fok:','Fok:','90'));
fok:=fok/180*pi;
if olvas=false then showmessage('Please open a file!') else
        begin
        Assignfile(f,filenev);
        reset(f,1);
        fileinfok(f,info);
        reset(f,1);
        progressbar1.Min:=start;
        progressbar1.max:=ending;
        progressbar1.Position:=start;
        for i:=start to ending do
                begin
                pos:=kepkocka(f,info,i);
                seek(f,pos);
                bitmaptomemory(f,nyitva,bmpm);
                bmpm:=rotate(bmpm,nyitva,nyitva.bmpinfo.biwidth div 2,nyitva.bmpinfo.biheight div 2,fok);
                seek(f,pos);
                bmpkiir(f,bmpm,nyitva);
                progressbar1.StepBy(1);
                end;
        showmessage('Kesz!');
        closefile(f);
        end;
dispose(bmpm);
end;

procedure TForm1.LinearFilter1Click(Sender: TObject);
var f:file;
    pos:dword;
    bmp:tbmphead;
    bmpm:tbmpmemory;
    i:integer;
    start,ending:integer;
    sugar:integer;
    info:tfileinfo;
begin
new(bmpm);
start:=strtoint(inputbox('Start','Start','1'));
ending:=strtoint(inputbox('End','End','100'));
sugar:=strtoint(inputbox('End','End','3'));
if olvas=false then showmessage('Please open a file!') else
        begin
        Assignfile(f,filenev);
        reset(f,1);
        fileinfok(f,info);
        progressbar1.Min:=start;
        progressbar1.max:=ending;
        progressbar1.Position:=start;
        for i:=start to ending do
                begin
                pos:=kepkocka(f,info,i);
                seek(f,pos);
                bitmaptomemory(f,nyitva,bmpm);
                bmpm:=linear(bmpm,nyitva,sugar);
                seek(f,pos);
                bmpkiir(f,bmpm,nyitva);
                progressbar1.StepBy(1);
                end;
        showmessage('Kesz!');
        closefile(f);
        end;
dispose(bmpm);
end;

procedure masolfile(var mibol,mibe:file;
                    honnan:integer;
                    mennyit:integer;
                    finfo:tfileinfo;
                    var bmp:tbmphead;
                    var bmpm:tbmpmemory
                    );

var i,size:integer;
    chunk:fourcc;
    pos:integer;

begin
for i:=0 to mennyit do
    begin
    chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
    form1.fourccir(mibe,chunk);
    pos:=kepkocka(mibol,finfo,i+honnan);
    seek(mibol,pos);
    size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
    blockwrite(mibe,size,sizeof(size));
    bitmaptomemory(mibol,bmp,bmpm);
    bmpkiir(mibe,bmpm,bmp);
    form1.progressbar1.stepby(1);
    end;
end;

procedure TForm1.Blending1Click(Sender: TObject);
var f,g,h:file;
    head:Taviheader;
    i,j:integer;
    stream:Tavistreamheader;
    atido:integer;
    bmp,bmp2:Tbmphead;
    fsec,gsec:integer;
    sec,n,m:integer;
    ki,bmpm:TBmpmemory;
    chunk:fourcc;
    pos:dword;
    size:integer;
    k:boolean;
    finfo,ginfo:tfileinfo;

begin
new(bmpm);
new(ki);
if olvas then
begin
opendialog1.execute;
Assignfile(g,opendialog1.filename);
reset(g,1);
fileinfok(g,ginfo);
reset(g,1);
Assignfile(f,filenev);
reset(f,1);
fileinfok(f,finfo);
reset(f,1);
Assignfile(h,kimenet);
rewrite(h,1);
atido:=strtoint(inputbox('Attunesi ido','Attunesi ido','75'));
aviheaderolvas(f,bmp,stream,head);
fsec:=head.dwTotalFrames;
aviheaderolvas(g,bmp2,stream,head);
gsec:=head.dwTotalFrames;
n:=fsec+gsec-atido;
sec:=round(n/25);
osszehasonlit(bmp,bmp2,k);
if k then
   begin
   aviheaderir(h,sec,n,bmp);
   progressbar1.min:=0;
   progressbar1.Max:=n;
   progressbar1.Position:=0;

   masolfile(f,h,1,fsec-atido-1,finfo,bmp,bmpm);

   n:=atido;
   for i:=0 to atido-1 do
        begin
        chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
        fourccir(h,chunk);
        size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
        blockwrite(h,size,sizeof(size));
        pos:=kepkocka(f,finfo,fsec-atido+i);
        seek(f,pos);
        bitmaptomemory(f,bmp,bmpm);
        pos:=kepkocka(g,ginfo,i);
        seek(g,pos);
        bitmaptomemory(g,bmp,ki);
        ki:=blending(ki,bmpm,bmp,n,i);
        bmpkiir(h,ki,bmp);
        progressbar1.StepBy(1);
        end;

   masolfile(g,h,atido,gsec-atido-1,ginfo,bmp,bmpm);

   n:=fsec+gsec-atido;
   idxir(h,n,bmp.bmpinfo.biWidth,bmp.Bmpinfo.biHeight);
   end else showmessage('Nem osszerakhato a ket video!');
end else showmessage('Please open the input file!');
dispose(bmpm);
dispose(ki);
if olvas then
begin
closefile(f);
closefile(g);
closefile(h);
end;
if k then showmessage('Kesz');
end;

procedure TForm1.Teszt1Click(Sender: TObject);
var f,g,h:file;
    bmp,bmp2:tbmphead;
    i,j,k:integer;
    l1,l2,l3:^tline;
    rz,gz,bz,r1,g1,b1:longint;
    kulonbseg,epsz:real;
    scanline,pos:integer;
    c:tcolor;
    finfo,ginfo:tfileinfo;
begin
new(l1);
new(l2);
new(l3);
opendialog1.execute;
Assignfile(f,opendialog1.filename);
reset(f,1);
fileinfok(f,finfo);
reset(f,1);
Assignfile(g,'352288.bmp');
reset(g,1);
fileinfok(g,ginfo);
reset(g,1);
Assignfile(h,'out.bmp');
rewrite(h,1);
//bmpolvas(f,bmp,1);
pos:=kepkocka(f,finfo,3);
seek(f,pos);
bmpolvas(g,bmp2,1);
bmp_headkiir(h,bmp2,true);
form1.ColorDialog1.Execute;
c:=form1.ColorDialog1.Color;
rz:=getrvalue(c);
gz:=getgvalue(c);
bz:=getbvalue(c);
epsz:=10;
scanline:=bmp2.bmpinfo.biwidth*3;
for i:=bmp2.bmpinfo.biheight-1 downto 0 do
        begin
        blockread(f,l1^,scanline);
        blockread(g,l2^,scanline);
        k:=0;
        for j:=0 to bmp2.Bmpinfo.biWidth-1 do
                begin
                r1:=l1^[k];
                g1:=l1^[k+1];
                b1:=l1^[k+2];
                kulonbseg:=sqrt((rz-r1)*(rz-r1) + (gz-g1)*(gz-g1) + (bz-b1)*(bz-b1));
                if abs(kulonbseg)<=epsz then
                        begin
                        l3^[k]:=l2^[k];
                        l3^[k+1]:=l2^[k+1];
                        l3^[k+2]:=l2^[k+2];
                        end else
                                begin
                                l3^[k]:=l1^[k];
                                l3^[k+1]:=l1^[k+1];
                                l3^[k+2]:=l1^[k+2];
                                end;
                k:=k+3;
                form1.Canvas.Pixels[j,i+50]:=rgb(l3^[k+2],l3^[k+1],l3^[k]);
                end;
        blockwrite(h,l3^,scanline);
        end;
dispose(l1);
dispose(l2);
dispose(l3);
closefile(f);
closefile(g);
closefile(h);
end;

procedure bmpkiirmaszk(var f:file; bmph:tbmphead; bmp,bmp2:tbmpmemory; var bmpm:tbmpmemory);
var i,j:integer;
    scanline:integer;
    line:^Tline;
begin
new(line);
scanline:=bmph.Bmpinfo.biWidth*3;
if scanline mod 4 <>0 then showmessage('Hiba with the scanline')
        else begin
             for i:=bmph.Bmpinfo.biHeight-1 downto 0 do
                begin
                for j:=0 to bmph.Bmpinfo.biWidth*3-3 do
                        begin
                        if bmpm^[i,j]=1 then line^[j]:=bmp^[i,j] else line^[j]:=bmp2^[i,j];
                        end;
                blockwrite(f,line^,scanline);
                end;
             end;
dispose(line);
end;

function tele(bmpm:tbmpmemory; bmp:tbmpHead):boolean;
var i,j:integer;
        t:boolean;
begin
t:=true;
i:=1;
while (i<=bmp.bmpinfo.biwidth) and (t) do
        begin
        i:=i+1;
        for j:=0 to bmp.bmpinfo.biheight-1 do
                begin
                if bmpm^[j,i]<>2 then t:=false;
                end;
        end;
tele:=t;
end;

procedure TForm1.Veletlen1Click(Sender: TObject);
var f,g,h:file;
    head:Taviheader;
    i,j,k,l:integer;
    stream:Tavistreamheader;
    atido:integer;
    bmp,bmp2:Tbmphead;
    fsec,gsec:integer;
    sec,n,m:integer;
    ki,bmpm,ki2:TBmpmemory;
    chunk:fourcc;
    pos:dword;
    size,terulet:integer;
    kul:boolean;
    finfo,ginfo:tfileinfo;
begin

new(bmpm);
new(ki);
new(ki2);
if olvas then
begin
opendialog1.execute;
Assignfile(g,opendialog1.filename);
reset(g,1);
fileinfok(g,ginfo);
reset(g,1);
Assignfile(f,filenev);
reset(f,1);
fileinfok(f,finfo);
reset(f,1);
Assignfile(h,kimenet);
rewrite(h,1);
atido:=strtoint(inputbox('Attunesi ido','Attunesi ido','75'));
aviheaderolvas(f,bmp,stream,head);
fsec:=head.dwTotalFrames;
aviheaderolvas(g,bmp2,stream,head);
gsec:=head.dwTotalFrames;
n:=fsec+gsec-atido;
sec:=round(n/25);
aviheaderir(h,sec,n,bmp);
progressbar1.min:=0;
progressbar1.Max:=n;
progressbar1.Position:=0;
osszehasonlit(bmp,bmp2,kul);
if kul then
        begin

        masolfile(f,h,1,fsec-atido-1,finfo,bmp,bmpm);

        n:=atido;
        terulet:=(bmp.Bmpinfo.biheight-1)*(bmp.Bmpinfo.biWidth-1);
        for j:=0 to bmp.Bmpinfo.biWidth*3-3 do
                for k:=0 to bmp.Bmpinfo.biHeight-1 do
                        ki2^[k,j]:=1;
        for i:=0 to atido-1 do
                begin
                chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
                fourccir(h,chunk);
                size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
                blockwrite(h,size,sizeof(size));

                pos:=kepkocka(f,finfo,fsec-atido+i);
                seek(f,pos);
                bitmaptomemory(f,bmp,bmpm);
                pos:=kepkocka(g,ginfo,i);
                seek(g,pos);
                bitmaptomemory(g,bmp,ki);
                for j:=0 to round(terulet/atido) do
                   begin
                     repeat
                     k:=random(bmp.bmpinfo.biwidth);
                     l:=random(bmp.bmpinfo.biheight);
                     until ((ki2^[l,3*k]=1) and ((ki2^[l,3*k+1]=1)) and (ki2^[l,3*k+2]=1));// or (tele(ki2,bmp));
                   ki2^[l,3*k]:=2;
                   ki2^[l,3*k+1]:=2;
                   ki2^[l,3*k+2]:=2;
                   end;
                bmpkiirmaszk(h,bmp,bmpm,ki,ki2);
                progressbar1.StepBy(1);
                end;

        masolfile(g,h,atido,gsec-atido-1,ginfo,bmp,bmpm);

        n:=fsec+gsec-atido;
        idxir(h,n,bmp.bmpinfo.biWidth,bmp.Bmpinfo.biHeight);
       end;
end else showmessage('Please open the input file!');
dispose(bmpm);
dispose(ki);
dispose(ki2);
if olvas then
begin
closefile(f);
closefile(g);
closefile(h);
end;
showmessage('Kesz');
end;

function bilinear(bmpm:Tbmpmemory; bmph:tbmphead; ujmeretx,ujmerety:integer; var kihead:tbmphead):tbmpmemory;
var xarany,yarany:real;
    ujxa,ujxf:integer;
    ujya,ujyf:integer;
    tortx,torty,emtx,emty:real;
    i,j:integer;
    ki:tbmpmemory;
    b1,b2:real;
begin
new(ki);
xarany:=bmph.Bmpinfo.biWidth/ujmeretx;
yarany:=bmph.Bmpinfo.biHeight/ujmerety;
for i:=ujmerety downto 0 do
        begin
        for j:=0 to ujmeretx-1 do
                begin
                ujxa:=floor(j*xarany);
                ujya:=floor(i*yarany);
                ujxf:=ujxa+3;
                if ujxf>bmph.bmpinfo.biWidth-3 then ujxf:=ujxa;
                ujyf:=ujya+1;
                if ujyf>bmph.bmpinfo.biheight-1 then ujyf:=ujya;
                tortx:=j*xarany-ujxa;
                torty:=i*yarany-ujya;
                emtx:=1-tortx;
                emty:=1-torty;

                b1:=emtx*bmpm^[ujya,3*ujxa]+tortx*bmpm^[ujya,3*ujxf];
                b2:=emtx*bmpm^[ujyf,3*ujxa]+tortx*bmpm^[ujyf,3*ujxf];
                ki^[i,3*j]:=round(emty*b1+torty*b2);
                b1:=emtx*bmpm^[ujya,3*ujxa+1]+tortx*bmpm^[ujya,3*ujxf+1];
                b2:=emtx*bmpm^[ujyf,3*ujxa+1]+tortx*bmpm^[ujyf,3*ujxf+1];
                ki^[i,3*j+1]:=round(emty*b1+torty*b2);
                b1:=emtx*bmpm^[ujya,3*ujxa+2]+tortx*bmpm^[ujya,3*ujxf+2];
                b2:=emtx*bmpm^[ujyf,3*ujxa+2]+tortx*bmpm^[ujyf,3*ujxf+2];
                ki^[i,3*j+2]:=round(emty*b1+torty*b2);
                end;
        end;
kihead:=bmph;
kihead.Filehead.bfSize:=ujmeretx*ujmerety*3+54;
kihead.Bmpinfo.biWidth:=ujmeretx;;
kihead.bmpinfo.biHeight:=ujmerety;;
kihead.Bmpinfo.biSizeImage:=ujmeretx*ujmerety*3;
bilinear:=ki;
end;

procedure TForm1.Resizing1Click(Sender: TObject);
var f,h:file;
    kihead,bmp:tbmphead;
    bmpm,ki:Tbmpmemory;
    n,m:integer;
    ujmeretx,ujmerety:integer;
    chunk:fourcc;
    size,fsec:integer;
    stream:Tavistreamheader;
    head:Taviheader;
    pos:dword;
    info:tfileinfo;

begin
new(bmpm);
new(ki);
assignfile(f,filenev);
Reset(f,1);
fileinfok(f,info);
reset(f,1);
aviheaderolvas(f,bmp,stream,head);
n:=head.dwTotalFrames;
assignfile(h,kimenet);
rewrite(h,1);
//fsec:=stream.dwLength;
repeat
ujmeretx:=strtoint(inputbox('Szelesseg: ','Szelesseg',inttostr(bmp.Bmpinfo.biWidth)));
until ujmeretx mod 4=0;
ujmerety:=strtoint(inputbox('Magassag: ','Magassag',inttostr(bmp.bmpinfo.biheight)));
pos:=kepkocka(f,info,1);
seek(f,pos);
bitmaptomemory(f,bmp,bmpm);
ki:=bilinear(bmpm,bmp,ujmeretx,ujmerety,kihead);
Aviheaderir(h,fsec,n,kihead);
progressbar1.Min:=0;
progressbar1.Max:=n;
progressbar1.Position:=1;
for m:=0 to n-1 do
  begin
  chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
  fourccir(h,chunk);
  size:=kihead.Bmpinfo.biWidth*kihead.Bmpinfo.biHeight*3;
  blockwrite(h,size,sizeof(size));
  pos:=kepkocka(f,info,m);
  seek(f,pos);
  bitmaptomemory(f,bmp,bmpm);
  ki:=bilinear(bmpm,bmp,ujmeretx,ujmerety,kihead);
  bmpkiir(h,ki,kihead);
  progressbar1.stepby(1);
  end;
idxir(h,n,kihead.bmpinfo.biwidth,kihead.bmpinfo.biheight);
dispose(ki);
dispose(bmpm);
closefile(f);
showmessage('Kesz');
end;

function tg(alfa:real):real;
begin
tg:=sin(alfa)/cos(alfa);
end;

procedure TForm1.Kocksods1Click(Sender: TObject);
var f,g,h:file;
    head:Taviheader;
    i,j,k,l:integer;
    stream:Tavistreamheader;
    atido:integer;
    bmp,bmp2:Tbmphead;
    fsec,gsec:integer;
    sec,n,m,kx,ky:integer;
    ki,bmpm,ki2:TBmpmemory;
    chunk:fourcc;
    pos:dword;
    size,terulet:integer;
    kul:boolean;
    tgalfa,alfa:real;
    finfo,ginfo:tfileinfo;

begin

new(bmpm);
new(ki);
new(ki2);
if olvas then
   begin
  opendialog1.execute;
  Assignfile(g,opendialog1.filename);
  reset(g,1);
  fileinfok(g,ginfo);
  reset(g,1);
  Assignfile(f,filenev);
  reset(f,1);
  fileinfok(f,finfo);
  reset(f,1);
  Assignfile(h,kimenet);
  rewrite(h,1);
  atido:=strtoint(inputbox('Attunesi ido','Attunesi ido','25'));
  aviheaderolvas(f,bmp,stream,head);
  fsec:=head.dwTotalFrames;
  aviheaderolvas(g,bmp2,stream,head);
  gsec:=head.dwTotalFrames;
  n:=fsec+gsec-atido;
  sec:=round(n/25);
  aviheaderir(h,sec,n,bmp);
  progressbar1.min:=0;
  progressbar1.Max:=n;
  progressbar1.Position:=0;
  osszehasonlit(bmp,bmp2,kul);
  if kul then
        begin

        masolfile(f,h,1,fsec-atido-1,finfo,bmp,bmpm);

        n:=atido;
        terulet:=(bmp.Bmpinfo.biheight-1)*(bmp.Bmpinfo.biWidth-1);
        for j:=0 to bmp.Bmpinfo.biWidth*3-3 do
                for k:=0 to bmp.Bmpinfo.biHeight-1 do
                        ki2^[k,j]:=1;
        alfa:=0;
        kx:=bmp.bmpinfo.biwidth div 2;
        ky:=bmp.bmpinfo.biheight div 2;
        for i:=0 to atido-1 do
                begin
                chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
                fourccir(h,chunk);
                size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
                blockwrite(h,size,sizeof(size));

                pos:=kepkocka(f,finfo,fsec-atido+i);
                seek(f,pos);
                bitmaptomemory(f,bmp,bmpm);
                pos:=kepkocka(g,ginfo,i);
                seek(g,pos);
                bitmaptomemory(g,bmp,ki);
                {for j:=0 to round(terulet/atido) do
                   begin
                     repeat
                     k:=random(bmp.bmpinfo.biwidth);
                     l:=random(bmp.bmpinfo.biheight);
                     until ((ki2^[l,3*k]=1) and ((ki2^[l,3*k+1]=1)) and (ki2^[l,3*k+2]=1));// or (tele(ki2,bmp));
                   ki2^[l,3*k]:=2;
                   ki2^[l,3*k+1]:=2;
                   ki2^[l,3*k+2]:=2;
                   end;}
                tgalfa:=alfa/180*pi;
                if alfa<90 then
                   begin
                   for l:=(bmp.Bmpinfo.biheight div 2)-1 downto 0 do
                        begin
                        for k:=0 to (bmp.bmpinfo.biwidth div 2)-1 do
                                begin
                                if ki2^[l,3*k]<>2 then
                                        begin
                                        if ky<>l then
                                           begin
                                                if (kx-k)/(ky-l)<tg(tgalfa) then
                                                        begin
                                                        ki2^[l,k*3]:=2;
                                                        ki2^[l,k*3+1]:=2;
                                                        ki2^[l,k*3+2]:=2;
                                                        end;
                                           end;
                                        end;
                                end;
                        end;
                   end else
                        if (alfa>90) and (alfa<=180) then
                                begin
                                for l:=bmp.Bmpinfo.biheight-1 downto (bmp.bmpinfo.biheight div 2) do
                                        begin
                                        for k:=0 to (bmp.bmpinfo.biwidth div 2)-1 do
                                                begin
                                                if ki2^[l,3*k]<>2 then
                                                        begin
                                                        if ky<>l then
                                                            begin
                                                                if (kx-k)/(ky-l)<tg(tgalfa) then
                                                                   begin
                                                                   ki2^[l,3*k]:=2;
                                                                   ki2^[l,3*k+1]:=2;
                                                                   ki2^[l,3*k+2]:=2;
                                                                   end;
                                                            end;
                                                        end;
                                                end;
                                        end;
                                end
                            else
                            if (alfa>180) and (alfa<270) then
                                begin
                                for l:=bmp.Bmpinfo.biheight-1 downto (bmp.bmpinfo.biheight div 2) do
                                        begin
                                        for k:=(bmp.bmpinfo.biwidth div 2)-1 to bmp.bmpinfo.biwidth-1 do
                                                begin
                                                if ki2^[l,3*k]<>2 then
                                                        begin
                                                        if ky<>l then
                                                            begin
                                                                if (k-kx)/(l-ky)<tg(tgalfa) then
                                                                   begin
                                                                   ki2^[l,3*k]:=2;
                                                                   ki2^[l,3*k+1]:=2;
                                                                   ki2^[l,3*k+2]:=2;
                                                                   end;
                                                            end;
                                                        end;
                                                end;
                                        end;
                                end else
                                    if (alfa>270) and (alfa<=360) then
                                    begin
                                    for l:=(bmp.bmpinfo.biheight div 2) downto 0 do
                                        begin
                                        for k:=(bmp.bmpinfo.biwidth div 2)-1 to bmp.bmpinfo.biwidth-1 do
                                                begin
                                                if ki2^[l,3*k]<>2 then
                                                        begin
                                                        if ky>l then
                                                            begin
                                                                if (kx-k)/(ky-l)<tg(tgalfa) then
                                                                   begin
                                                                   ki2^[l,3*k]:=2;
                                                                   ki2^[l,3*k+1]:=2;
                                                                   ki2^[l,3*k+2]:=2;
                                                                   end;
                                                            end;
                                                        end;
                                                end;
                                        end;
                                    end;
                           // end;

                bmpkiirmaszk(h,bmp,bmpm,ki,ki2);
                progressbar1.StepBy(1);
                alfa:=alfa+360/atido;
                end;

        masolfile(g,h,atido,gsec-atido-1,ginfo,bmp,bmpm);

        n:=fsec+gsec-atido;
        idxir(h,n,bmp.bmpinfo.biWidth,bmp.Bmpinfo.biHeight);
       end else showmessage('A ket kep nem osszeillesztheto!');
  end else showmessage('Please open the input file!');
dispose(bmpm);
dispose(ki);
dispose(ki2);
if olvas then
   begin
   closefile(f);
   closefile(g);
   closefile(h);
   end;
showmessage('Kesz');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
savedialog1.execute;
edit5.text:=savedialog1.filename;
kimenet:=edit5.text;
end;

procedure TForm1.Sztnyils1Click(Sender: TObject);
var f,g,h:file;
    head:Taviheader;
    i,j,l,lepkoz:integer;
    stream:Tavistreamheader;
    atido:integer;
    bmp,bmp2:Tbmphead;
    fsec,gsec:integer;
    sec,n,m:integer;
    ki,bmpm,ki2:TBmpmemory;
    chunk:fourcc;
    pos:dword;
    size:integer;
    kul:boolean;
    finfo,ginfo:tfileinfo;
begin

new(bmpm);
new(ki);
new(ki2);
if olvas then
begin
opendialog1.execute;
Assignfile(g,opendialog1.filename);
reset(g,1);
fileinfok(g,ginfo);
reset(g,1);
Assignfile(f,filenev);
reset(f,1);
fileinfok(f,finfo);
reset(f,1);
Assignfile(h,kimenet);
rewrite(h,1);
atido:=strtoint(inputbox('Attunesi ido','Attunesi ido','75'));
aviheaderolvas(f,bmp,stream,head);
fsec:=head.dwTotalFrames;
aviheaderolvas(g,bmp2,stream,head);
gsec:=head.dwTotalFrames;
n:=fsec+gsec-atido;
sec:=round(n/25);
aviheaderir(h,sec,n,bmp);
progressbar1.min:=0;
progressbar1.Max:=n;
progressbar1.Position:=0;
osszehasonlit(bmp,bmp2,kul);
if kul then
        begin

        masolfile(f,h,1,fsec-atido-1,finfo,bmp,bmpm);

        n:=atido;
        for j:=0 to bmp.Bmpinfo.biWidth*3-3 do
                for l:=0 to bmp.Bmpinfo.biHeight-1 do
                        ki2^[l,j]:=1;
        lepkoz:=round(bmp.bmpinfo.biwidth/atido);
        for i:=0 to atido-1 do
                begin
                chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
                fourccir(h,chunk);
                size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
                blockwrite(h,size,sizeof(size));

                pos:=kepkocka(f,finfo,fsec-atido+i);
                seek(f,pos);
                bitmaptomemory(f,bmp,bmpm);
                pos:=kepkocka(g,ginfo,i);
                seek(g,pos);
                bitmaptomemory(g,bmp,ki);

                for j:=(i-1)*lepkoz-1 to i*lepkoz-1 do
                        begin
                        for l:=bmp.Bmpinfo.biHeight-1 downto 1 do
                           begin
                           ki2^[l,3*j]:=2;
                           ki2^[l,3*j+1]:=2;
                           ki2^[l,3*j+2]:=2;
                           end;
                        end;

                bmpkiirmaszk(h,bmp,bmpm,ki,ki2);
                progressbar1.StepBy(1);
                end;

        masolfile(g,h,atido,gsec-atido-1,ginfo,bmp,bmpm);

        n:=fsec+gsec-atido;
        idxir(h,n,bmp.bmpinfo.biWidth,bmp.Bmpinfo.biHeight);
       end;
end else showmessage('Please open the input file!');
dispose(bmpm);
dispose(ki);
dispose(ki2);
if olvas then
begin
closefile(f);
closefile(g);
closefile(h);
end;
showmessage('Kesz');
end;

procedure TForm1.Kzprl1Click(Sender: TObject);
var f,g,h:file;
    head:Taviheader;
    i,j,l,lepkoz:integer;
    stream:Tavistreamheader;
    atido:integer;
    bmp,bmp2:Tbmphead;
    fsec,gsec:integer;
    sec,n,m:integer;
    ki,bmpm,ki2:TBmpmemory;
    chunk:fourcc;
    pos:dword;
    size:integer;
    kul:boolean;
    finfo,ginfo:tfileinfo;
begin

new(bmpm);
new(ki);
new(ki2);
if olvas then
begin
opendialog1.execute;
Assignfile(g,opendialog1.filename);
reset(g,1);
fileinfok(g,ginfo);
reset(g,1);
Assignfile(f,filenev);
reset(f,1);
fileinfok(f,finfo);
reset(f,1);
Assignfile(h,kimenet);
rewrite(h,1);
atido:=strtoint(inputbox('Attunesi ido','Attunesi ido','75'));
aviheaderolvas(f,bmp,stream,head);
fsec:=head.dwTotalFrames;
aviheaderolvas(g,bmp2,stream,head);
gsec:=head.dwTotalFrames;
n:=fsec+gsec-atido;
sec:=round(n/25);
aviheaderir(h,sec,n,bmp);
progressbar1.min:=0;
progressbar1.Max:=n;
progressbar1.Position:=0;
osszehasonlit(bmp,bmp2,kul);
if kul then
        begin

        masolfile(f,h,0,fsec-atido-1,finfo,bmp,bmpm);

        n:=atido;
        for j:=0 to bmp.Bmpinfo.biWidth*3-3 do
                for l:=0 to bmp.Bmpinfo.biHeight-1 do
                        ki2^[l,j]:=1;

        lepkoz:=round(bmp.bmpinfo.biwidth/2/atido);
        for i:=0 to atido-1 do
                begin
                chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
                fourccir(h,chunk);
                size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
                blockwrite(h,size,sizeof(size));

                pos:=kepkocka(f,finfo,fsec-atido+i);
                seek(f,pos);
                bitmaptomemory(f,bmp,bmpm);
                pos:=kepkocka(g,ginfo,i);
                seek(g,pos);
                bitmaptomemory(g,bmp,ki);

                for j:=(i-1)*lepkoz-1 to i*lepkoz-1 do
                        begin
                        for l:=bmp.Bmpinfo.biHeight-1 downto 1 do
                           begin
                           ki2^[l,3*j]:=2;
                           ki2^[l,3*j+1]:=2;
                           ki2^[l,3*j+2]:=2;
                           ki2^[l,3*(bmp.bmpinfo.biwidth-j)]:=2;
                           ki2^[l,3*(bmp.bmpinfo.biwidth-j)+1]:=2;
                           ki2^[l,3*(bmp.bmpinfo.biwidth-j)+2]:=2;
                           end;
                        end;

                bmpkiirmaszk(h,bmp,bmpm,ki,ki2);
                progressbar1.StepBy(1);
                end;

        masolfile(g,h,atido,gsec-atido-1,ginfo,bmp,bmpm);

        n:=fsec+gsec-atido;
        idxir(h,n,bmp.bmpinfo.biWidth,bmp.Bmpinfo.biHeight);
       end;
end else showmessage('Please open the input file!');
dispose(bmpm);
dispose(ki);
dispose(ki2);
if olvas then
begin
closefile(f);
closefile(g);
closefile(h);
end;
showmessage('Kesz');
end;


procedure bmp_to_tbitmap(var f:file; bmp:Tbmphead; sz:byte; var bitmap:tbitmap);
type Tline=array[0..25000] of byte;
var i,j,k:integer;
    scanline:integer;
    line:^tline;
    pal:array[1..2500] of tpaletta;
    c:Tcolor;
begin
if bmp.Bmpinfo.biBitCount=24 then
        begin
        scanline:=bmp.bmpinfo.biwidth*3;
        new(line);
        for i:=bmp.Bmpinfo.biHeight-1 downto 0 do
                begin
                blockread(f,line^,scanline);
                k:=0;
                for j:=0 to bmp.Bmpinfo.biWidth-1 do
                        begin
                        if sz<>1 then bitmap.canvas.pixels[j,i]:=rgb(line^[k],line^[k+2],line^[k+1])
                                 else bitmap.canvas.pixels[j,i]:=rgb(line^[k+2],line^[k+1],line^[k]);
                        k:=k+3;
                        end;
                end;
        dispose(line);
        end;
end;

procedure bitmapcanvas_tomemory(var bmpmemory:TBmpMemory; bitmap:tbitmap);
var i,j,k:integer;
    scanline:integer;
    color:tcolor;
    cr,cg,cb:byte;
begin
scanline:=bitmap.width*3;
if scanline mod 4<>0 then showmessage('Hibas scanline!')
   else begin
        for i:=bitmap.Height-1 downto 0 do
                begin
                //blockread(f,line^,scanline);
                k:=0;
                for j:=0 to bitmap.Width-1 do
                        begin
                        color:=bitmap.Canvas.Pixels[j,i];
                        cr:=getrvalue(color);
                        cg:=getgvalue(color);
                        cb:=getbvalue(color);
                        bmpmemory^[i,k]:=cb;
                        bmpmemory^[i,k+1]:=cg;
                        bmpmemory^[i,k+2]:=cr;
                        k:=k+3;
                        end;
                end;
        end;
end;


procedure TForm1.Egyfeliatfelillesztse1Click(Sender: TObject);

var
    f,g:file;
    pos:dword;
    info:tfileinfo;
    x,y:integer;
    szoveg:string;
    bmpm:tbmpmemory;
    sec,n,i,size:integer;
    chunk:fourcc;
//    bitmap:tbitmap;

begin
new(bmpm);
//bitmap:=tbitmap.create;
//bitmap.Empty;
if olvas=false then showmessage('Please open a file!') else
        begin
        fontdialog1.execute;
        canvas.Font:=fontdialog1.Font;
        szoveg:=inputbox('Szoveg bekeres','Szoveg bekeres','');
        x:=strtoint(inputbox('x bekerese','x bekerese',''));
        y:=strtoint(inputbox('y bekerese','y bekerese',''));

        Assignfile(f,filenev);
        reset(f,1);
        fileinfok(f,info);
        Assignfile(g,edit5.text);
        rewrite(g,1);
        sec:=strtoint(edit3.text);
        n:=sec*25;
        progressbar1.min:=0;
        progressbar1.max:=n;
        progressbar1.Position:=0;
        Aviheaderir(g,sec,n,nyitva);
        for i:=0 to n-1 do
           begin
           pos:=kepkocka(f,info,i);
           seek(f,pos);
           bmp_megjelenit(f,nyitva,1);
           SetBkMode(canvas.handle,TRANSPARENT);
           form1.canvas.textout(x,y,szoveg);
           canvastomemory(bmpm,rect(0,80,nyitva.Bmpinfo.biWidth,80+nyitva.bmpinfo.biHeight));
           chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
           fourccir(g,chunk);
           size:=nyitva.Bmpinfo.biWidth*nyitva.Bmpinfo.biHeight*3;
           blockwrite(g,size,sizeof(size));
           bmpkiir(g,bmpm,nyitva);
           progressbar1.Stepby(1);
           end;

        idxir(g,n,nyitva.bmpinfo.biwidth,nyitva.bmpinfo.biheight);
        closefile(f);
        showmessage('Kesz!');
        end;
dispose(bmpm);
end;

function keres(n:integer; fname:string):string;
var ch:char;
    sub:text;
    szam1,szam2:integer;
    s,sv:string;
    talalt:boolean;
    j,ok,k:integer;
begin

Assign(sub,fname);
reset(sub);

talalt:=false;
repeat
read(sub,ch);
until (ch='{') or (eof(sub));

while (not(eof(sub))) and (not(talalt)) do
      begin
      if ch='{' then
          begin

          readln(sub,s);
          j:=pos('}{',s);
          if j<>0 then
             begin
             sv:='';
             for k:=1 to j-1 do sv:=sv+s[k];
             val(sv,szam1,ok);
             delete(s,1,j+1);
             ok:=pos('}',s);
             sv:='';
             for k:=1 to ok do sv:=sv+s[k];
             val(sv,szam2,ok);
             delete(s,1,ok);
             end;

          end;
      if (n>=szam1) and (n<=szam2) then talalt:=true;
      end;

if talalt then keres:=s;
closefile(sub);
end;

procedure TForm1.Subfilealillesztse1Click(Sender: TObject);
var
    sfilename:string;
    f,g:file;
    pos:dword;
    bmpm:tbmpmemory;
    sec,n,i,size:integer;
    chunk:fourcc;
    info:tfileinfo;
    szoveg:string;
    siz:tsize;
begin
new(bmpm);
if olvas then
   begin
   opendialog1.execute;
   sfilename:=opendialog1.filename;
   fontdialog1.execute;
   canvas.font:=fontdialog1.Font;

   Assignfile(f,filenev);
   reset(f,1);
   fileinfok(f,info);
   Assignfile(g,edit5.text);
   rewrite(g,1);
   sec:=strtoint(edit3.text);
   n:=sec*25;
   progressbar1.min:=0;
   progressbar1.max:=n;
   progressbar1.Position:=0;
   Aviheaderir(g,sec,n,nyitva);

   for i:=0 to n-1 do
        begin
        pos:=kepkocka(f,info,i);
        seek(f,pos);
        bmp_megjelenit(f,nyitva,1);
        SetBkMode(canvas.handle,TRANSPARENT);

        szoveg:=keres(i,sfilename);
        siz:=form1.Canvas.TextExtent(szoveg);
        form1.Canvas.TextOut((nyitva.bmpinfo.biwidth div 2) - (siz.cx div 2),80+nyitva.bmpinfo.biheight-siz.cy-20,szoveg);
        canvastomemory(bmpm,rect(0,80,nyitva.Bmpinfo.biWidth,80+nyitva.bmpinfo.biHeight));
        chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
        fourccir(g,chunk);
        size:=nyitva.Bmpinfo.biWidth*nyitva.Bmpinfo.biHeight*3;
        blockwrite(g,size,sizeof(size));
        bmpkiir(g,bmpm,nyitva);
        progressbar1.Stepby(1);
        end;
   idxir(g,n,nyitva.bmpinfo.biwidth,nyitva.bmpinfo.biheight);
   closefile(f);
   closefile(g);
   showmessage('Kesz!');
   end else showmessage('Please open an input file');
dispose(bmpm);
end;

procedure TForm1.Circle21Click(Sender: TObject);
var f,g,h:file;
    head:Taviheader;
    r,i,j,k,kx,ky,lepesk:integer;
    tav:real;
    stream:Tavistreamheader;
    atido:integer;
    bmp,bmp2:Tbmphead;
    fsec,gsec:integer;
    sec,n,m:integer;
    ki,bmpm,ki2:TBmpmemory;
    chunk:fourcc;
    pos:dword;
    size,terulet:integer;
    kul:boolean;
    finfo,ginfo:tfileinfo;
begin

new(bmpm);
new(ki);
new(ki2);
if olvas then
begin
opendialog1.execute;
Assignfile(g,opendialog1.filename);
reset(g,1);
fileinfok(g,ginfo);
reset(g,1);
Assignfile(f,filenev);
reset(f,1);
fileinfok(f,finfo);
reset(f,1);
Assignfile(h,kimenet);
rewrite(h,1);
atido:=strtoint(inputbox('Attunesi ido','Attunesi ido','75'));
aviheaderolvas(f,bmp,stream,head);
fsec:=head.dwTotalFrames;
aviheaderolvas(g,bmp2,stream,head);
gsec:=head.dwTotalFrames;
n:=fsec+gsec-atido;
sec:=round(n/25);
aviheaderir(h,sec,n,bmp);
progressbar1.min:=0;
progressbar1.Max:=n;
progressbar1.Position:=0;
osszehasonlit(bmp,bmp2,kul);
if kul then
        begin

        masolfile(f,h,1,fsec-atido-1,finfo,bmp,bmpm);

        n:=atido;
        terulet:=(bmp.Bmpinfo.biheight-1)*(bmp.Bmpinfo.biWidth-1);
        for j:=0 to bmp.Bmpinfo.biWidth*3-3 do
                for k:=0 to bmp.Bmpinfo.biHeight-1 do
                        ki2^[k,j]:=1;
        r:=0;
        lepesk:=round(sqrt(  sqr(bmp.bmpinfo.biwidth div 2) + sqr(bmp.bmpinfo.biheight div 2)) / atido);
        for i:=0 to atido-1 do
                begin
                r:=r+lepesk;
                chunk[1]:='0';chunk[2]:='0';chunk[3]:='d';chunk[4]:='c';
                fourccir(h,chunk);
                size:=bmp.Bmpinfo.biWidth*bmp.Bmpinfo.biHeight*3;
                blockwrite(h,size,sizeof(size));

                pos:=kepkocka(f,finfo,fsec-atido+i);
                seek(f,pos);
                bitmaptomemory(f,bmp,bmpm);
                pos:=kepkocka(g,ginfo,i);
                seek(g,pos);
                bitmaptomemory(g,bmp,ki);

                //a megfelelo helyre a maszkban 2-ket rakok

                for j:=0 to bmp.Bmpinfo.biWidth*3-3 do
                        begin
                        for k:=0 to bmp.bmpinfo.biHeight-1 do
                                begin
                                //tavolsag meghatarozasa
                                kx:=abs(j-(bmp.Bmpinfo.biWidth div 2));
                                ky:=abs(k-(bmp.Bmpinfo.biheight div 2));
                                tav:=sqrt(kx*kx+ky*ky);
                                if tav<r then
                                        begin
                                        ki2^[k,3*j]:=2;
                                        ki2^[k,3*j+1]:=2;
                                        ki2^[k,3*j+2]:=2;
                                        end;
                                end;
                        end;

                bmpkiirmaszk(h,bmp,bmpm,ki,ki2);
                progressbar1.StepBy(1);
                end;

        masolfile(g,h,atido,gsec-atido-1,ginfo,bmp,bmpm);

        n:=fsec+gsec-atido;
        idxir(h,n,bmp.bmpinfo.biWidth,bmp.Bmpinfo.biHeight);
       end;
end else showmessage('Please open the input file!');
dispose(bmpm);
dispose(ki);
dispose(ki2);
if olvas then
begin
closefile(f);
closefile(g);
closefile(h);
end;
showmessage('Kesz');
end;
end.
